import { ICreateData } from './typings';
import type { worker, Position } from 'monaco-editor';
import * as monaco from 'monaco-editor';
import { SchemaConfig } from 'graphql-language-service';
import type { DocumentNode } from 'graphql';
export declare type MonacoCompletionItem = monaco.languages.CompletionItem & {
    isDeprecated?: boolean;
    deprecationReason?: string | null;
};
export declare class GraphQLWorker {
    private _ctx;
    private _languageService;
    private _formattingOptions;
    constructor(ctx: worker.IWorkerContext, createData: ICreateData);
    doValidation(uri: string): Promise<globalThis.monaco.editor.IMarkerData[]>;
    doComplete(uri: string, position: Position): Promise<(import("vscode-languageserver-types").CompletionItem & {
        isDeprecated?: boolean | undefined;
        documentation?: string | null | undefined;
        deprecationReason?: string | null | undefined;
        type?: import("graphql").GraphQLScalarType<unknown, unknown> | import("graphql").GraphQLObjectType<any, any> | import("graphql").GraphQLInterfaceType | import("graphql").GraphQLUnionType | import("graphql").GraphQLEnumType | import("graphql").GraphQLInputObjectType | import("graphql").GraphQLList<import("graphql").GraphQLType> | import("graphql").GraphQLNonNull<import("graphql").GraphQLInterfaceType | import("graphql").GraphQLUnionType | import("graphql").GraphQLEnumType | import("graphql").GraphQLInputObjectType | import("graphql").GraphQLScalarType<unknown, unknown> | import("graphql").GraphQLObjectType<any, any> | import("graphql").GraphQLList<import("graphql").GraphQLType>> | undefined;
    } & {
        range: globalThis.monaco.IRange;
    })[]>;
    doHover(uri: string, position: Position): Promise<{
        content: string | import("vscode-languageserver-types").MarkupContent | {
            language: string;
            value: string;
        } | import("vscode-languageserver-types").MarkedString[] | undefined;
        range: globalThis.monaco.IRange;
    } | null>;
    doGetVariablesJSONSchema(uri: string): Promise<unknown>;
    doFormat(uri: string): Promise<string | null>;
    doParse(text: string): Promise<DocumentNode>;
    private _getTextModel;
    doUpdateSchema(schema: SchemaConfig): void;
    doUpdateSchemas(schemas: SchemaConfig[]): Promise<void>;
}
declare const _default: {
    GraphQLWorker: typeof GraphQLWorker;
};
export default _default;
export declare function create(ctx: worker.IWorkerContext, createData: ICreateData): GraphQLWorker;
//# sourceMappingURL=GraphQLWorker.d.ts.map