import type { IRange as GraphQLRange, IPosition as GraphQLPosition, Diagnostic, CompletionItem as GraphQLCompletionItem, SchemaConfig } from 'graphql-language-service';
export declare type MonacoCompletionItem = monaco.languages.CompletionItem & {
    isDeprecated?: boolean;
    deprecationReason?: string | null;
};
export declare function toMonacoRange(range: GraphQLRange): monaco.IRange;
export declare function toGraphQLPosition(position: monaco.Position): GraphQLPosition;
export declare function toCompletion(entry: GraphQLCompletionItem, range?: GraphQLRange): GraphQLCompletionItem & {
    range: monaco.IRange;
};
export declare function toMarkerData(diagnostic: Diagnostic): monaco.editor.IMarkerData;
export declare const getStringSchema: (schemaConfig: SchemaConfig) => {
    documentString: string;
    uri: string;
    fileMatch?: string[] | undefined;
    buildSchemaOptions?: import("graphql").BuildSchemaOptions | undefined;
} | {
    introspectionJSONString: string;
    uri: string;
    fileMatch?: string[] | undefined;
    buildSchemaOptions?: import("graphql").BuildSchemaOptions | undefined;
};
//# sourceMappingURL=utils.d.ts.map